// Listen_ModeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Listen_Mode.h"
#include "Listen_ModeDlg.h"
#include "Listen_ModeDlg.h"
#include "..\lib\pisocancpm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListen_ModeDlg dialog

CListen_ModeDlg::CListen_ModeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CListen_ModeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CListen_ModeDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CListen_ModeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CListen_ModeDlg)
	DDX_Control(pDX, IDC_LIST_ENTRYDATA, m_entrydata);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_COMBO_COM, m_board);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_LOADEDS, m_btn_loadeds);
	DDX_Control(pDX, IDC_BUTTON_INITMASTER, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CListen_ModeDlg, CDialog)
	//{{AFX_MSG_MAP(CListen_ModeDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO_COM, OnSelchangeComboCom)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_BN_CLICKED(IDC_BUTTON_INITMASTER, OnButtonInitmaster)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_LOADEDS, OnButtonLoadeds)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CListen_ModeDlg message handlers

BYTE BOARD=0;
BYTE PORT=1;
BYTE BAUD=0;
BYTE NODE=1;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;

BYTE ISADD[128]={0};

BOOL CListen_ModeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	m_board.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_board.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_initial.ShowWindow(SW_SHOW);
	m_btn_shutdown.EnableWindow(TRUE);
	m_btn_shutdown.ShowWindow(SW_HIDE);
	m_btn_addnode.EnableWindow(FALSE);
	m_btn_addnode.ShowWindow(SW_SHOW);
	m_btn_loadeds.EnableWindow(FALSE);
	m_btn_loadeds.ShowWindow(SW_SHOW);
	m_btn_removenode.EnableWindow(FALSE);
	m_btn_removenode.ShowWindow(SW_HIDE);

	m_entrydata.ResetContent();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CListen_ModeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CListen_ModeDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CListen_ModeDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CListen_ModeDlg::OnSelchangeComboCom() 
{
	// TODO: Add your control notification handler code here
	BOARD = m_board.GetCurSel();
}

void CListen_ModeDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CListen_ModeDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;

	if(ISADD[NODE]){
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_removenode.ShowWindow(SW_SHOW);

		UpdateList();
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		m_entrydata.ResetContent();
	}
}

void CListen_ModeDlg::OnButtonInitmaster() 
{
	// TODO: Add your control notification handler code here
	ret = CPM_InitMaster(BOARD, PORT, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.EnableWindow(FALSE);
		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_shutdown.ShowWindow(SW_SHOW);
		m_btn_shutdown.EnableWindow(TRUE);		
		
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_loadeds.EnableWindow(TRUE);

		// Set to listen mode
		CPM_SetMasterMode(BOARD, PORT, 1, BlockMode);

		SetTimer(123,100,NULL);
	}
}

void CListen_ModeDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = CPM_ShutdownMaster(BOARD, PORT);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);

		m_btn_initial.EnableWindow(TRUE);
		m_btn_initial.ShowWindow(SW_SHOW);
		m_btn_shutdown.EnableWindow(FALSE);
		m_btn_shutdown.ShowWindow(SW_HIDE);
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_loadeds.EnableWindow(FALSE);
		m_btn_loadeds.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		m_node.EnableWindow(FALSE);
		m_node.SetCurSel(0);

		memset(ISADD,0,128);
		m_entrydata.ResetContent();

		KillTimer(123);
	}
}

void CListen_ModeDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	// Add Node manually
	ret = CPM_AddNode(BOARD, PORT, NODE, 2, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		BYTE EntryUse;
		WORD i, j, PDOId;
		DWORD EntryData[8];

		ISADD[NODE] = 1;

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_loadeds.EnableWindow(FALSE);
		m_btn_loadeds.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_removenode.ShowWindow(SW_SHOW);

		// Set EMCY ID to master list
		CPM_SetEMCY_List(BOARD, PORT, NODE, (0x80 + NODE), BlockMode);

		// Install RxPDO to master PDO list
		for(i=0;i<4;i++){
			PDOId = 0x200 + NODE + (0x100*i);

			if(i==0) EntryUse = 8;
			else EntryUse = 4;

			for(j=0;j<EntryUse;j++){
				if(i==0) EntryData[j] = 0x62000108 + (0x00000100*j);
				else EntryData[j] = 0x64110110 + (0x00000100*(j+((i-1)*EntryUse)));
			}

			CPM_InstallPDO_List(BOARD, PORT, NODE, PDOId, 0, i+1, 255, 0, EntryUse, EntryData, BlockMode);
		}	

		// Install TxPDO to master PDO list
		for(i=0;i<4;i++){
			PDOId = 0x180 + NODE + (0x100*i);

			if(i==0) EntryUse = 8;
			else EntryUse = 4;

			for(j=0;j<EntryUse;j++){
				if(i==0) EntryData[j] = 0x60000108 + (0x00000100*j);
				else EntryData[j] = 0x64010110 + (0x00000100*(j+((i-1)*EntryUse)));
			}

			CPM_InstallPDO_List(BOARD, PORT, NODE, PDOId, 1, i+1, 255, 0, EntryUse, EntryData, BlockMode);
		}
	}
}

void CListen_ModeDlg::OnButtonLoadeds() 
{
	// TODO: Add your control notification handler code here
	CFileDialog Open(TRUE,NULL,NULL,OFN_HIDEREADONLY,_T("EDS File (*.eds)|*.eds"));

	INT_PTR nRet = Open.DoModal();
	if (nRet== IDOK)
	{
		char FileName[100] = {0};

		sprintf(FileName, "%s", Open.GetPathName());
		
		ret = CPM_EDS_Load(BOARD, PORT, NODE, FileName, DelayTime, 200, BlockMode);
        if (ret != 0)
        {
			errstr.Format(_T("EDS File Load Error = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}
        else
        {
			ISADD[NODE] = 1;

            m_btn_addnode.EnableWindow(FALSE);
            m_btn_addnode.ShowWindow(SW_HIDE);
            m_btn_loadeds.EnableWindow(FALSE);
            m_btn_loadeds.ShowWindow(SW_HIDE);
            m_btn_removenode.EnableWindow(TRUE);
			m_btn_removenode.ShowWindow(SW_SHOW);
		}
	}
}

void CListen_ModeDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = CPM_RemoveNode(BOARD, PORT, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		ISADD[NODE] = 0;

		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_loadeds.EnableWindow(TRUE);
		m_btn_loadeds.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		m_entrydata.ResetContent();
	}
}

void CListen_ModeDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	CPM_ShutdownMaster(BOARD, PORT);
}

void CListen_ModeDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	UpdateList();

	CDialog::OnTimer(nIDEvent);
}

void CListen_ModeDlg::UpdateList()
{
	WORD Ret;
	BYTE PDO_Cnt, NMT_State;
	WORD EMCYId, Id_List[10], i, j;
	CString Temp_Str;

	m_entrydata.ResetContent();

	Ret = CPM_NMTGetState(BOARD, PORT, NODE, &NMT_State, BlockMode);
	if(!Ret){
		Temp_Str.Format(_T("NMT State:"));
		switch(NMT_State){
		case 0x04:  // Stop mode
			Temp_Str.Format(_T("%s Stop mode"),Temp_Str);
			break;
		case 0x05:  // Operation mode
			Temp_Str.Format(_T("%s Operation mode"),Temp_Str);
			break;
		case 0x7F:	// Pre-operation mode
			Temp_Str.Format(_T("%s Pre-operation mode"),Temp_Str);
			break;
		}
		m_entrydata.AddString(Temp_Str);
	}

	Ret = CPM_GetEMCYID(BOARD, PORT, NODE, &EMCYId, BlockMode);
	if(!Ret){
		if(EMCYId){
			BYTE IsNew, Data[8]={0};
			Ret = CPM_ReadLastEMCY(BOARD, PORT, NODE, &IsNew, Data, BlockMode);
			if(!Ret || (Ret == CPM_DataEmpty)){
				Temp_Str.Format(_T("EMCY %X : "),EMCYId);
				for(i=0;i<8;i++){
					Temp_Str.Format(_T("%s%02X "),Temp_Str,Data[i]);
				}
				m_entrydata.AddString(Temp_Str);
			}
		}
	}

	Ret = CPM_GetRxPDOID(BOARD, PORT, NODE, &PDO_Cnt, Id_List, BlockMode);
	if(!Ret){
		BYTE IsNew, DLen, Data[8];

		for(i=0;i<PDO_Cnt;i++){
			memset(Data,0,8);

			Ret = CPM_GetPDOLastData(BOARD, PORT, Id_List[i], &IsNew, &DLen, Data, BlockMode);
			if(!Ret || (Ret == CPM_DataEmpty)){
				Temp_Str.Format(_T("RxPDO %X : "),Id_List[i]);
				for(j=0;j<8;j++){
					Temp_Str.Format(_T("%s%02X "),Temp_Str,Data[j]);
				}
				m_entrydata.AddString(Temp_Str);
			}
		}
	}

	Ret = CPM_GetTxPDOID(BOARD, PORT, NODE, &PDO_Cnt, Id_List, BlockMode);
	if(!Ret){
		BYTE IsNew, DLen, Data[8];

		for(i=0;i<PDO_Cnt;i++){
			memset(Data,0,8);

			Ret = CPM_GetPDOLastData(BOARD, PORT, Id_List[i], &IsNew, &DLen, Data, BlockMode);
			if(!Ret || (Ret == CPM_DataEmpty)){
				Temp_Str.Format(_T("TxPDO %X : "),Id_List[i]);
				for(j=0;j<8;j++){
					Temp_Str.Format(_T("%s%02X "),Temp_Str,Data[j]);
				}
				m_entrydata.AddString(Temp_Str);
			}
		}
	}
}