// PDO_MultiDataDlg.h : header file
//

#if !defined(AFX_PDO_MULTIDATADLG_H__47C57E60_3637_441B_A618_9CC3977DF8D3__INCLUDED_)
#define AFX_PDO_MULTIDATADLG_H__47C57E60_3637_441B_A618_9CC3977DF8D3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPDO_MultiDataDlg dialog

class CPDO_MultiDataDlg : public CDialog
{
// Construction
public:
	CPDO_MultiDataDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CPDO_MultiDataDlg)
	enum { IDD = IDD_PDO_MULTIDATA_DIALOG };
	CListBox	m_pdolist;
	CComboBox	m_node;
	CComboBox	m_board;
	CComboBox	m_baud;
	CButton	m_btn_shutdown;
	CButton	m_btn_settimer;
	CButton	m_btn_setpolling;
	CButton	m_btn_remove;
	CButton	m_btn_initial;
	CButton	m_btn_addnode;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPDO_MultiDataDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	void Enable_Disable(bool Sta);

	// Generated message map functions
	//{{AFX_MSG(CPDO_MultiDataDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeComboComport();
	afx_msg void OnSelchangeComboBaud();
	afx_msg void OnSelchangeComboNode();
	afx_msg void OnButtonInitial();
	afx_msg void OnButtonShutdown();
	afx_msg void OnButtonAddnode();
	afx_msg void OnButtonRemove();
	afx_msg void OnButtonSettimer();
	afx_msg void OnButtonSetpolling();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PDO_MULTIDATADLG_H__47C57E60_3637_441B_A618_9CC3977DF8D3__INCLUDED_)
