// PDO_ParameterDlg.h : header file
//

#if !defined(AFX_PDO_PARAMETERDLG_H__12FC1799_E6A2_43D4_BF09_BA66D8D8DE7F__INCLUDED_)
#define AFX_PDO_PARAMETERDLG_H__12FC1799_E6A2_43D4_BF09_BA66D8D8DE7F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CPDO_ParameterDlg dialog

class CPDO_ParameterDlg : public CDialog
{
// Construction
public:
	CPDO_ParameterDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CPDO_ParameterDlg)
	enum { IDD = IDD_PDO_PARAMETER_DIALOG };
	CButton	m_btn_removepdo;
	CListBox	m_mapdata;
	CEdit	m_useentry;
	CEdit	m_transmittype;
	CEdit	m_installpdono;
	CEdit	m_installpdoid;
	CEdit	m_eventtimer;
	CEdit	m_setentrydata;
	CEdit	m_setentry;
	CEdit	m_changepdoid;
	CComboBox	m_pdotype;
	CComboBox	m_pdoid;
	CComboBox	m_node;
	CComboBox	m_rxtxtype;
	CComboBox	m_board;
	CComboBox	m_baud;
	CButton	m_btn_shutdown;
	CButton	m_btn_removenode;
	CButton	m_btn_useentry;
	CButton	m_btn_txtype;
	CButton	m_btn_installpdo;
	CButton	m_btn_initial;
	CButton	m_btn_eventtimer;
	CButton	m_btn_dynamicpdo;
	CButton	m_btn_changepdo;
	CButton	m_btn_addnode;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPDO_ParameterDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	void Enable_Disable(bool Sta);
	void GetPDOID();
	void GetPDOMapData();
	// Generated message map functions
	//{{AFX_MSG(CPDO_ParameterDlg)
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeComboCom();
	afx_msg void OnSelchangeComboBaud();
	afx_msg void OnSelchangeComboNode();
	afx_msg void OnButtonInitial();
	afx_msg void OnButtonShutdown();
	afx_msg void OnButtonAddnode();
	afx_msg void OnButtonRemove();
	afx_msg void OnButtonInstallpdo();
	afx_msg void OnButtonRemovepdo();
	afx_msg void OnButtonDynamicpdo();
	afx_msg void OnButtonChangepdo();
	afx_msg void OnButtonPdotxtype();
	afx_msg void OnButtonPdouseentry();
	afx_msg void OnButtonEventtimer();
	afx_msg void OnDestroy();
	afx_msg void OnSelchangeComboPdoid();
	afx_msg void OnSelchangeComboPdotype();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PDO_PARAMETERDLG_H__12FC1799_E6A2_43D4_BF09_BA66D8D8DE7F__INCLUDED_)
